From 00a183e5d2066f96b4a7c630588559864d25e610 Mon Sep 17 00:00:00 2001
From: Portisch <hugo.portisch@yahoo.de>
Date: Tue, 14 Jan 2025 09:25:55 +0100
Subject: [PATCH 6/9] [VideoPlayer] Do not render overlay when there is no
 libass event active Render empty overlay can cause stutter by calling
 TrySwapBuffers caused by waiting for a vblank.

---
 xbmc/cores/VideoPlayer/VideoPlayerVideo.cpp | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/xbmc/cores/VideoPlayer/VideoPlayerVideo.cpp b/xbmc/cores/VideoPlayer/VideoPlayerVideo.cpp
index 67bfe45ff6..99f178e629 100644
--- a/xbmc/cores/VideoPlayer/VideoPlayerVideo.cpp
+++ b/xbmc/cores/VideoPlayer/VideoPlayerVideo.cpp
@@ -13,6 +13,7 @@
 #include "DVDCodecs/Overlay/DVDOverlay.h"
 #include "DVDCodecs/Video/DVDVideoCodecFFmpeg.h"
 #include "ServiceBroker.h"
+#include "cores/VideoPlayer/DVDCodecs/Overlay/DVDOverlayLibass.h"
 #include "cores/VideoPlayer/Interface/DemuxPacket.h"
 #include "cores/VideoPlayer/Interface/TimingConstants.h"
 #include "settings/AdvancedSettings.h"
@@ -896,6 +897,11 @@ void CVideoPlayerVideo::ProcessOverlays(const VideoPicture* pSource, double pts)
         continue;
 
       double pts2 = pOverlay->bForced ? pts : pts - m_iSubtitleDelay;
+      auto libassOverlay = std::dynamic_pointer_cast<CDVDOverlayLibass>(pOverlay);
+      if (libassOverlay) {
+        if (!libassOverlay->GetLibassHandler()->EventActive(pts2))
+          continue;
+      }
 
       if((pOverlay->iPTSStartTime <= pts2 && (pOverlay->iPTSStopTime > pts2 || pOverlay->iPTSStopTime == 0LL)))
       {
-- 
2.43.0

